<?php
class SearchClass {
    private $options;

    public function __construct(){
        $content_url = wp_upload_dir();
        $this->options = get_option( 'sf_pa_autosuggest_plugin_options' );
        $this->count = 6;
        $this->content_url = $content_url['baseurl'];
        $this->products = array();
    }

    public function search($sf_pa_search){
        global $wpdb;

        $prepare =  array($this->options['show_cat'], $this->options['show_thumbnail'], '%' . $wpdb->esc_like($sf_pa_search) .'%');
        $join = '';
        $where = '';

        //Check if site use wpml
        if (class_exists('SitePress')) {
            $lang = esc_sql(apply_filters( 'wpml_current_language', NULL ));
            $join = " LEFT JOIN ".$wpdb->prefix."icl_translations ON ".$wpdb->prefix."icl_translations.element_id = ".$wpdb->prefix."posts.ID AND element_type = 'post_product'";
            $where = " AND ".$wpdb->prefix."icl_translations.language_code = %s";
            $prepare[] = $lang;
        }

        $sql = "SELECT ".$wpdb->prefix."posts.post_title, ".$wpdb->prefix."posts.guid as link, img_postmeta.meta_value as img_url,  ".$wpdb->prefix."terms.name as cat_title, %s as show_cat, %s as show_thumbnail  FROM ".$wpdb->prefix."posts
                LEFT JOIN ".$wpdb->prefix."postmeta ON ".$wpdb->prefix."postmeta.post_id =  ".$wpdb->prefix."posts.ID AND ".$wpdb->prefix."postmeta.meta_key = '_thumbnail_id'
                LEFT JOIN ".$wpdb->prefix."postmeta as img_postmeta ON img_postmeta.post_id =  ".$wpdb->prefix."postmeta.meta_value AND img_postmeta.meta_key = '_wp_attachment_metadata'
                LEFT JOIN ".$wpdb->prefix."term_relationships ON ".$wpdb->prefix."term_relationships.object_id = ".$wpdb->prefix."posts.ID
                LEFT JOIN ".$wpdb->prefix."terms ON ".$wpdb->prefix."terms.term_id = ".$wpdb->prefix."term_relationships.term_taxonomy_id
                LEFT JOIN ".$wpdb->prefix."term_taxonomy ON ".$wpdb->prefix."term_taxonomy.term_id = ".$wpdb->prefix."terms.term_id
                ".$join."
                WHERE ".$wpdb->prefix."posts.post_title LIKE %s AND ".$wpdb->prefix."posts.post_type = 'product' AND ".$wpdb->prefix."posts.post_status = 'publish'
                AND ".$wpdb->prefix."term_taxonomy.taxonomy = 'product_cat'". $where;
                

        if(isset($this->options['exclude_ids']) && !empty($this->options['exclude_ids'])){
            $sql .=  "AND ".$wpdb->prefix."posts.id NOT IN (%s)";
            $prepare[] = $this->options['exclude_ids'];
        }
        if(isset($this->options['results_count']) && !empty($this->options['results_count'])){
            $this->count = $this->options['results_count'];
        }
        $sql .= " GROUP BY ".$wpdb->prefix."posts.ID LIMIT %d";

        $prepare[] = $this->count;
        
        $results_prod = $wpdb->get_results($wpdb->prepare($sql, $prepare));
        foreach($results_prod as $single_prod){
            $single_prod->img_url = $this->get_thumb_from_serialize($single_prod->img_url);
            $single_prod->post_title =  esc_html($single_prod->post_title);
            $single_prod->cat_title = esc_html($single_prod->cat_title);
            $single_prod->link = esc_url($single_prod->link);
            $this->products[] = $single_prod;
        }
        $this->products = apply_filters('sf_pa_autosuggest_results', $this->products);
        return $this->products;
    }

    private function get_thumb_from_serialize($serialize_data){
        $data = maybe_unserialize($serialize_data);
        if($data){
            if (!empty( $data['sizes'] )) {
                $sizes = $data['sizes'];
                if(isset($sizes['thumbnail']['file']) && !empty($sizes['thumbnail']['file'])){
                    $file = $sizes['thumbnail']['file'];
                    if ( '.' !== $path = dirname( $data['file'] ) ){
                        $file = "$this->content_url/$path/$file";
                        return esc_url($file);
                    } 
                }
            }
        }
        return '';
    }
}